<?php
/**
 * CHRONOCONNECTIVITY version 2.0 stable
 * Copyright (c) 2008 Chrono_Man, ChronoEngine.com. All rights reserved.
 * Author: Chrono_Man (ChronoEngine.com)
 * See readme.html.
 * @license		GNU/GPL
 * Visit http://www.ChronoEngine.com for regular update and information.
 **/

/* ensure that this file is called by another file */
defined('_JEXEC') or die('Restricted access');



/**
 * Load the HTML class
 */
require_once( JApplicationHelper::getPath( 'front_html' ) ); 
require_once( JApplicationHelper::getPath( 'class' ) );
jimport( 'joomla.application.component.controller' );

require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );
$mainframe =& JFactory::getApplication('site');
$mainframe->initialise();

require_once( JPATH_COMPONENT.DS.'libraries'.DS.'connection.php');
require_once( JPATH_COMPONENT.DS.'libraries'.DS.'permissions.php');
require_once( JPATH_COMPONENT.DS.'libraries'.DS.'data.php');

$connectionname = JRequest::getWord('connectionname');
if ( !$connectionname ) {
	$params =& $mainframe->getPageParameters('com_chronoconnectivity');
	$connectionname = $params->get('connectionname');
}
$MyConnection =& CFChronoConnection::getInstance($connectionname);
if(!$MyConnection->connectionrow->id){
	echo "There is no connection with this name";
	return;
}else{
	eval ("?>".$MyConnection->connectionrow->ClassCode);
}


switch( $task ) {
	case 'showlist':
		showlist();
		break;
	case 'deleterecord':
		deleterecord($option, $connectionname);
		break;
	case 'editrecord':
	case 'newrecord':
		editrecord($option, $connectionname);
		break;
	case 'saverecord':
		saverecord($option, $connectionname);
		break;
	default:
		showmainlist($connectionname);
		break;
}


function showmainlist($connectionname)
{
    global $mainframe;
	$database =& JFactory::getDBO();	
	$session =& JFactory::getSession();    
	
	$MyConnection =& CFChronoConnection::getInstance($connectionname);
	//Loop POST and GET
	$posted = explode(",", $MyConnection->connectionparams('posted'));
	foreach($posted as $postname){
		if(JRequest::getVar( trim($postname), '', 'post', 'string')){
			$session->set("chronoconnectivity_post_".trim($postname), JRequest::getVar( trim($postname), '', 'post', 'string'), md5('chrono'));
		}
	}
	$geted = explode(",", $MyConnection->connectionparams('geted'));
	foreach($geted as $getname){
		if(JRequest::getVar( trim($getname), '', 'get', 'string')){
			$session->set("chronoconnectivity_get_".trim($getname), JRequest::getVar( trim($getname), '', 'get', 'string'), md5('chrono'));
		}
	}
		
	HTML_ChronoConnectivity::showmainlist( $MyConnection );	
	
}

function deleterecord($option, $connectionname){
	global $mainframe;
	$database =& JFactory::getDBO();
	
	$cids = JRequest::getVar( 'cids', '', 'get', 'string' );	
	
	$MyConnection =& CFChronoConnection::getInstance($connectionname);
	$MyPermissions =& CFChronoConnectionPermissions::getInstance($MyConnection->connectionrow->id);
	$primary = $MyConnection->connectionparams('primarykey');
	
	if(!$MyPermissions->checkPermissions('delete')){
		echo "You are not authorized to view this page";
		return;
	}
	
	if(!$MyPermissions->checkRowPermissions('delete', $cids)){
		echo "You are not authorized to view this page";
		return;
	}
	
	$database->setQuery( "DELETE FROM ".$MyConnection->connectionrow->tablenames." WHERE ".$primary." IN ($cids)" );
	if (!$database->query()) {
		JError::raiseWarning(100, $database->getErrorMsg());
		$mainframe->redirect( JRoute::_("index.php?option=com_chronoconnectivity&connectionname=".$MyConnection->connectionrow->name) );
	}
	$mainframe->redirect( JRoute::_("index.php?option=com_chronoconnectivity&connectionname=".$MyConnection->connectionrow->name) );
	
}

function editrecord($option, $connectionname){
	global $mainframe;
	$database =& JFactory::getDBO();	
	$cids = JRequest::getVar( 'cids', '', 'get', 'string');	
	$MyConnection =& CFChronoConnection::getInstance($connectionname);
	$MyConnection->editRow($connectionname, $cids);
}

function saverecord($option, $connectionname){
	global $mainframe;
	$database =& JFactory::getDBO();
	
	$MyConnection =& CFChronoConnection::getInstance($connectionname);
	$MyPermissions =& CFChronoConnectionPermissions::getInstance($MyConnection->connectionrow->id);
	$primary = $MyConnection->connectionparams('primarykey');
	$row =& JTable::getInstance(str_replace($mainframe->getCfg('dbprefix'), '', $MyConnection->connectionrow->tablenames), 'Table');
		
	$oldtask = 'newrecord';
	//check permissions
	if(JRequest::getVar($MyConnection->connectionparams('primarykey'))){
		if(!$MyPermissions->checkPermissions('edit')){
			echo "You are not authorized to view this page, Global Edit error";
			return;
		}
		if(!$MyPermissions->checkRowPermissions('edit', JRequest::getVar($MyConnection->connectionparams('primarykey')))){
			echo "You are not authorized to view this page, Row Edit Error";
			return;
		}
		$oldtask = 'editrecord';
	}else{
		if(!$MyPermissions->checkPermissions('new')){
			echo "You are not authorized to view this page, Global New Record Error";
			return;
		}
		$oldtask = 'newrecord';
	}
	
	require_once( JPATH_SITE.DS.'components'.DS.'com_chronocontact'.DS.'libraries'.DS.'chronoform.php');
	require_once( JPATH_SITE.DS.'components'.DS.'com_chronocontact'.DS.'libraries'.DS.'mails.php');
	require_once( JPATH_SITE.DS.'components'.DS.'com_chronocontact'.DS.'libraries'.DS.'customcode.php');
	require_once( JPATH_SITE.DS.'components'.DS.'com_chronocontact'.DS.'libraries'.DS.'chronoformuploads.php');
	require_once( JPATH_SITE.DS.'components'.DS.'com_chronocontact'.DS.'libraries'.DS.'plugins.php');
	require_once( JPATH_SITE.DS.'components'.DS.'com_chronocontact'.DS.'chronocontact.html.php');
	$SaveForm =& CFChronoForm::getInstance(trim($MyConnection->connectionparams('front_edit_form')));
	JRequest::setVar('chronoformname', trim($MyConnection->connectionparams('front_edit_form')));
	//reload edit form settings
	$adminFormFields = '<input type="hidden" name="option" value="com_chronoconnectivity" />
	<input type="hidden" name="'.$primary.'" value="'.$row->$primary.'" />
	<input type="hidden" name="task" value="saverecord" />';
	$SaveForm->setFormData('html', $SaveForm->formrow->html.$adminFormFields);
	$SaveForm->setFormData('submiturl', 'index.php?option=com_chronoconnectivity&connectionname='.$MyConnection->connectionrow->name);
	$SaveForm->setFormParam('captcha_dataload', '1');
	$SaveFormPlugins =& CFPlugins::getInstance($SaveForm->formrow->id);
	$pluginObject = new stdClass;
	$paramsString = 'parameter=cids
	table_name='.$MyConnection->connectionrow->tablenames.'
	field_name='.$primary.'
	default_param_value='.$row->$primary.'
	editable=Yes
	skippedarray=option,task
	evaluate=Yes';
	$pluginObject->params = $paramsString;
	$SaveFormPlugins->runPlugin('', array('ONLOAD', 'ONLOADONSUBMIT'), 'cf_profile', $pluginObject);
	//submit form
	$SaveForm->submitForm($SaveForm->formrow->name, array(), true);
	
	$post = JRequest::get( 'post' , JREQUEST_ALLOWRAW );
	$primary = $row->getKeyName();
	
	if($SaveForm->showFormErrors($SaveForm->formrow->name)){
		$pid = JRequest::getVar($primary);
		//$MyConnection->editRow($connectionname, $pid);
		return;
	}
	
	
	if($post[$primary]){
		$database->setQuery( "SELECT * FROM ".$MyConnection->connectionrow->tablenames." WHERE ".$primary."='".$post[$primary]."'" );
		$old_data = $database->loadAssoc();
		$post = array_merge($old_data, $post);
	}
	if (!$row->bind( $post )) {
		JError::raiseWarning(100, $row->getError());
		$mainframe->redirect( JRoute::_("index.php?option=com_chronoconnectivity&connectionname=".$MyConnection->connectionrow->name) );
	}	
	
	if(trim( $MyConnection->connectionparams('orderingname'))){
		if(!$post[$primary]){
			$row->ordering = $row->getNextOrder();   
		}		
	}	
	if (!$row->store()) {
		JError::raiseWarning(100, $row->getError());
		$mainframe->redirect( JRoute::_("index.php?option=com_chronoconnectivity&connectionname=".$MyConnection->connectionrow->name) );
	}
	
	$mainframe->redirect( JRoute::_("index.php?option=com_chronoconnectivity&connectionname=".$MyConnection->connectionrow->name) );
}


?>
