<?php
/**
 * CHRONOCONNECTIVITY version 2.0 stable
 * Copyright (c) 2008 Chrono_Man, ChronoEngine.com. All rights reserved.
 * Author: Chrono_Man (ChronoEngine.com)
 * See readme.html.
 * @license		GNU/GPL
 * Visit http://www.ChronoEngine.com for regular update and information.
 **/
defined('_JEXEC') or die('Restricted access'); 

class CFChronoConnectionPermissions extends JObject{
	var $connectionid;
	function __construct($connectionid){		
		if (!isset($connectionid)) {
			JError::raiseWarning( '1001', 'LOADING FAILED::Permissions Class' );
			$retval = false;
			return $retval;
		}
		else
		{
			//initialise
			$this->connectionid = $connectionid;
		}
	}
	function &getInstance($connectionid){
		static $instances;
		if (!isset ($instances)) {
			$instances = array (  );
		}
		if (empty($instances[$connectionid])) {
			$instances[$connectionid] = new CFChronoConnectionPermissions($connectionid);
		}
		return $instances[$connectionid];
	}
	function checkPermissions( $type )
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		$user = JFactory::getuser();
		$connectionname = CFChronoConnection::getConnectionName($this->connectionid);
		$MyConnection =& CFChronoConnection::getInstance($connectionname);
		${'auth'.$type} = false;
		if(trim($MyConnection->connectionparams('auth'.$type.'_groups', '')) == ''){
			${'auth'.$type.'_groups'} = array();
		}else{
			${'auth'.$type.'_groups'} = explode(",", $MyConnection->connectionparams('auth'.$type.'_groups', ''));
		}
		if(trim($MyConnection->connectionparams('auth'.$type.'_users', '')) == ''){
			${'auth'.$type.'_users'} = array();
		}else{
			${'auth'.$type.'_users'} = explode(",", $MyConnection->connectionparams('auth'.$type.'_users', ''));			
		}
		//global permissions
		if(in_array($user->gid, ${'auth'.$type.'_groups'})){
			${'auth'.$type} = true;
		}else if(in_array($user->id, ${'auth'.$type.'_users'})){
			${'auth'.$type} = true;
		}else{
			${'auth'.$type} = false;
		}
		return ${'auth'.$type};
	}
	function setRowPermissions($type, $MyRow, $content, $overrideTrue = false)
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		$session =& JFactory::getSession();
		$user = JFactory::getuser();
		$connectionname = CFChronoConnection::getConnectionName($this->connectionid);
		$MyConnection =& CFChronoConnection::getInstance($connectionname);
		if(!$overrideTrue){
			if(preg_match('/{'.$type.'_record}/', $content)){
				${$type.'_perm_array'} = $session->get('chronoconnectivity_record'.$type.'_'.$MyConnection->connectionrow->name, array(), md5('chrono'));
				if(!in_array($MyRow->{$MyConnection->connectionparams('primarykey')}, ${$type.'_perm_array'})){
					${$type.'_perm_array'}[] = $MyRow->{$MyConnection->connectionparams('primarykey')};
				}
				$session->set('chronoconnectivity_record'.$type.'_'.$MyConnection->connectionrow->name, ${$type.'_perm_array'}, md5('chrono'));
			}else{
				//do nothing
			}
		}else{
			${$type.'_perm_array'} = $session->get('chronoconnectivity_record'.$type.'_'.$MyConnection->connectionrow->name, array(), md5('chrono'));
			if(!in_array($MyRow->{$MyConnection->connectionparams('primarykey')}, ${$type.'_perm_array'})){
				${$type.'_perm_array'}[] = $MyRow->{$MyConnection->connectionparams('primarykey')};
			}
			$session->set('chronoconnectivity_record'.$type.'_'.$MyConnection->connectionrow->name, ${$type.'_perm_array'}, md5('chrono'));
		}
	}
	function checkRowPermissions($type, $cids)
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		$session =& JFactory::getSession();
		$user = JFactory::getuser();
		$connectionname = CFChronoConnection::getConnectionName($this->connectionid);
		$MyConnection =& CFChronoConnection::getInstance($connectionname);
		if(!in_array($cids, $session->get('chronoconnectivity_record'.$type.'_'.$MyConnection->connectionrow->name, array(), md5('chrono')))){
			return false;
		}else{
			return true;
		}
	}	
}